#!/bin/bash

STATE_READY_INSTALL="allreadytoinstall"
STATE_NO_UPDATE="noupdates"
STATE_INSTALLING="installing"
STATE_TRANSFERRING="transferring"
UPDATE_STATE=$STATE_NO_UPDATE
UPDATE_CHANNEL="latest"

while [ 1 ]
do
  ## check update status
  sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "select * from config2 where key='swupdatestate'" > /dev/null

  if [[ $? == 0 ]]
  then
    UPDATE_STATE=$(sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "select * from config2 where key='swupdatestate'" | cut -d'|' -f2)
  fi

  ## check update channel
  sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "select * from config2 where key='updatechannel'" > /dev/null

  if [[ $? == 0 ]]
  then
    UPDATE_CHANNEL=$(sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "select * from config2 where key='updatechannel'" | cut -d'|' -f2)
  fi

  if [[ $UPDATE_STATE == $STATE_TRANSFERRING ]]
  then
    echo "preparing update..."

    USCRIPT="rpi-deconz-${UPDATE_CHANNEL}.sh"
    UURL="http://www.dresden-elektronik.de/rpi/deconz/${USCRIPT}"

    cd /tmp

    # remove old update script if exist
    if [ -e "$USCRIPT" ]; then
        rm $USCRIPT

        if [ $? -ne 0 ]; then
            echo "error removing old update scrip"
            continue
        fi
    fi

    # get latest update script
    wget $UURL

    if [ $? -ne 0 ]; then
        echo "error downloading update script"
        continue
    fi

    # Download ok now install
    UPDATE_STATE=$STATE_INSTALLING

  fi

  if [[ $UPDATE_STATE == $STATE_INSTALLING ]]
  then
    echo "installing update..."
    sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "update config2 set value='${STATE_INSTALLING}' where key='swupdatestate'" > /dev/null
    chmod +x $USCRIPT
    exec ./$USCRIPT

    if [[ $? == 0 ]]
    then
      # update successfull
      echo "success!"
      sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "update config2 set value='${STATE_NO_UPDATE}' where key='swupdatestate'" > /dev/null
      UPDATE_STATE=$STATE_NO_UPDATE
    else
      # an error occured during update
      echo "error during update installation"
      sqlite3 /home/pi/.local/share/dresden-elektronik/deCONZ/zll.db "update config2 set value='${STATE_READY_INSTALL}' where key='swupdatestate'" > /dev/null
      UPDATE_STATE=$STATE_READY_INSTALL
    fi
  fi

  sleep 10
done
